/// <reference types="node" />
import * as args from './args';
import * as flags from './flags';
import { Input, ParserOutput } from '../interfaces';
export { args };
export { flags };
export { flagUsages } from './help';
export declare function parse<TFlags, GFlags, TArgs extends {
    [name: string]: string;
}>(argv: string[], options: Input<TFlags, GFlags>): Promise<ParserOutput<TFlags, GFlags, TArgs>>;
declare const boolean: typeof flags.boolean, integer: typeof flags.integer, url: import("../interfaces").Definition<import("url").URL>, directory: typeof flags.directory, file: typeof flags.file;
export { boolean, integer, url, directory, file };
